#ifndef LS_ARRAY1
#define LS_ARRAY1
#include "ls_names.h"
#include LS_ERROR_H

template <class T>
class ls_array1 // Eindimensionale Felder
{ protected:
  T *a;
  char ONAME[ls_len];                  // Objektname
  ls_UINT dim;                         // Felddimension
  void set_data(T *aa=NULL,ls_UINT d=0){ a=aa, dim=d;}
  public:
  char* name;                          // Zeiger auf Objektnamen
  ls_array1(ls_UINT =0,char* ="ls_array1");// Standardkonstruktor
  ls_array1(ls_array1<T> &);           // move-Konstruktor
  ls_array1(T*,ls_UINT,char* ="ls_array1");// Feld-bernahme
  ~ls_array1();
  ls_array1<T>& swap(ls_array1<T> &);  // Datenfelder-Austausch
  ls_UINT dimension() const{ return dim;}
  T* asArray()const{ return a;}
  T& operator[](ls_UINT) const;        // indizierter Zugriff
  const ls_array1<T>& operator=(const ls_array1<T> &);
  ls_array1<T>& put_array(const ls_array1<T>&,ls_UINT =0);
                                      // Feldeingabe ab Position
  ls_array1<T>& put_array(T, ls_UINT =0); // Elementeing. ab Pos.
  ls_array1<T>& put(T, ls_UINT);       // Elementeingabe auf Pos.
  T get(ls_UINT);                      // Elementausgabe von Pos.
  const ls_array1<T>& get_array(ls_array1<T> &,
                                ls_UINT =0) const;
                                       // Feldausgabe ab Pos.
  ls_array1<T>& append(ls_UINT =1);    // Nullelemente anhngen
  ls_array1<T>& remove(ls_UINT);       // Element entfernen
  ls_array1<T>& remove();              // Feld entfernen
  const ls_array1<T>& write(ostream&)const;// in Datei schreiben
  ls_array1<T>& read(istream &);       // aus Datei lesen
  const ls_array1<T>& operator>>(char*)const;// in namentl. Datei
  ls_array1<T>& operator<<(char*);     // aus namentl. Datei
};
#ifndef LS_LIB
#include LS_ARRAY1_C
#endif
#endif
