#ifndef LS_BMATRIX
#define LS_BMATRIX
#include "ls_names.h"
#include LS_VECTOR_H
#include LS_ARRAY1M_H

class ls_bMatrix: public ls_array1M<ls_REAL>
{ public:
  ls_bMatrix(ls_UINT =0,char* ="ls_bMatrix");
  ls_bMatrix(ls_bMatrix &);
  operator ls_array1M<ls_REAL>&(){ return *this;}
  const ls_bMatrix& operator=(const ls_bMatrix &);//A=B
  ls_UINT number_of_diagonals() const{ return n;}
  ls_Vector operator* (ls_Vector &);              //A*x
  ls_UINT solve(ls_Vector &x, ls_Vector &b);      //cg-Verfahren
};
#ifndef LS_LIB
#include LS_BMATRIX_C
#endif
#endif
