// oberes Dreiecksfeld

#ifndef LS_ARRAYU
#define LS_ARRAYU
#include "ls_names.h"
#include LS_ARRAY2_H

template <class T>
class ls_arrayU: public ls_array1<T>
{ protected:
  ls_UINT n;
  void set_data(ls_UINT nn=0){ n=nn;}
  public:
  ls_arrayU(ls_UINT =0, char* ="ls_arrayU");
  ls_arrayU(ls_arrayU<T>&);
  ~ls_arrayU(){}
  ls_arrayU<T>& swap(ls_arrayU<T>&);
  T* operator[](ls_UINT k) const;
  ls_UINT dimension() const{ return n;}
  const ls_arrayU<T>& operator=(const ls_arrayU<T> &);
  ls_arrayU<T>& put(T, ls_UINT, ls_UINT);
  ls_arrayU<T>& put_row(const ls_array1<T>&, ls_UINT =0,
                        ls_UINT =0);
  ls_arrayU<T>& put_row(T, ls_UINT, ls_UINT);
  ls_arrayU<T>& put_column(const ls_array1<T>&, 
                           ls_UINT =0, ls_UINT =0);
  ls_arrayU<T>& put_column(T, ls_UINT, ls_UINT);
  ls_arrayU<T>& put_diagonal(const ls_array1<T>&, 
                             ls_UINT =0, ls_UINT =0);
  ls_arrayU<T>& put_diagonal(T, ls_UINT =0, ls_UINT =0);
  T get(ls_UINT, ls_UINT) const;
  const ls_arrayU<T>& get_row(ls_array1<T>&, 
                              ls_UINT =0, ls_UINT =0) const;
  const ls_arrayU<T>& get_column(ls_array1<T>&, 
                              ls_UINT =0, ls_UINT =0) const;
  const ls_arrayU<T>& get_diagonal(ls_array1<T>&,
                              ls_UINT =0, ls_UINT =0) const;
  const ls_arrayU<T>& get_array(ls_array2<T>&) const;
  ls_arrayU<T>& append_column(ls_UINT =1);
  ls_arrayU<T>& swap(ls_UINT, ls_UINT);
  ls_arrayU<T>& remove(ls_UINT);
  ls_arrayU<T>& remove();
  const ls_arrayU<T>& write_row(ostream &) const;
  ls_arrayU<T>& read_row(istream &);
  const ls_arrayU<T>& write_column(ostream &) const;
  ls_arrayU<T>& read_column(istream &);
  const ls_arrayU<T>& operator>> (char *) const;
  ls_arrayU<T>& operator<< (char *);
};
#ifndef LS_LIB
#include LS_ARRAYU_C
#endif
#endif
