#ifndef LS_NAMES
#define LS_NAMES

// alle Fehlerausschriften:

#define size_error_                    "size error."
#define index_error_                   "index error."
#define object_not_empty_              "object is not empty."
#define object_is_empty_               "object is empty."
#define object_end_error_              "object end error."
#define object_contents_error_         "object contents error."
#define object_not_found_              "object not found."
#define dimension_error_               "dimension error."
#define set_ls_REAL_to_double_         "set ls_REAL to double."
#define no_factorization_given_        "no factorization given."
#define object_not_positive_definit_   "object not positive definite"
#define no_memory_                     "no memory."
#define object_not_quadratic_          "object not quadratic."

// alle Schlsselwrter:

#define number_of_rows_                "number_of_rows:"
#define number_of_columns_             "number_of_columns:"
#define dimension_                     "dimension:"
#define number_of_elements_            "number_of_elements:"
#define number_of_arrays_              "number_of_arrays:"
#define column_                        "column:"
#define row_                           "row:"

// Dateinamen:

#define LS_ERROR_H           "ls_error.h"
#define LS_ERROR_C           "ls_error.cpp"
#define LS_ARRAY1_H          "ls_array1.h"
#define LS_ARRAY1_C          "ls_array1.cpp"
#define LS_ARRAY2_H          "ls_array2.h"
#define LS_ARRAY2_C          "ls_array2.cpp"
#define LS_ARRAYUS_H         "ls_arrayUs.h"
#define LS_ARRAYUS_C         "ls_arrayUs.cpp"
#define LS_ARRAYU_H          "ls_arrayU.h"
#define LS_ARRAYU_C          "ls_arrayU.cpp"
#define LS_ARRAY1M_H         "ls_array1M.h"
#define LS_ARRAY1M_C         "ls_array1M.cpp"
#define LS_BMATRIX_H         "ls_bMatrix.h"
#define LS_BMATRIX_C         "ls_bMatrix.cpp"
#define LS_GS_H              "ls_GS.h"
#define LS_GS_C              "ls_GS.cpp"
#define LS_INV_H             "ls_INV.h"
#define LS_INV_C             "ls_INV.cpp"
#define LS_INVCOLUMN_H       "ls_INV_column.h"
#define LS_INVCOLUMN_C       "ls_INV_column.cpp"
#define LS_INVDIAGONAL_H     "ls_INV_diagonal.h"
#define LS_INVDIAGONAL_C     "ls_INV_diagonal.cpp"
#define LS_INVROW_H          "ls_INV_row.h"
#define LS_INVROW_C          "ls_INV_row.cpp"
#define LS_INVTOTAL_H        "ls_INV_total.h"
#define LS_INVTOTAL_C        "ls_INV_total.cpp"
#define LS_LDLT_H            "ls_LDLT.h"
#define LS_LDLT_C            "ls_LDLT.cpp"
#define LS_LDLTDIAGONAL_H    "ls_LDLT_diagonal.h"
#define LS_LDLTDIAGONAL_C    "ls_LDLT_diagonal.cpp"
#define LS_LU_H              "ls_LU.h"
#define LS_LU_C              "ls_LU.cpp"
#define LS_LUCOLUMN_H        "ls_LU_column.h"
#define LS_LUCOLUMN_C        "ls_LU_column.cpp"
#define LS_LUDIAGONAL_H      "ls_LU_diagonal.h"
#define LS_LUDIAGONAL_C      "ls_LU_diagonal.cpp"
#define LS_LUROW_H           "ls_LU_row.h"
#define LS_LUROW_C           "ls_LU_row.cpp"
#define LS_LUTOTAL_H         "ls_LU_total.h"
#define LS_LUTOTAL_C         "ls_LU_total.cpp"
#define LS_MATRIX_H          "ls_Matrix.h"
#define LS_MATRIX_C          "ls_Matrix.cpp"
#define LS_QR_H              "ls_QR.h"
#define LS_QR_C              "ls_QR.cpp"
#define LS_SMATRIX_H         "ls_sMatrix.h"
#define LS_SMATRIX_C         "ls_sMatrix.cpp"
#define LS_UMATRIX_H         "ls_uMatrix.h"
#define LS_UMATRIX_C         "ls_uMatrix.cpp"
#define LS_VECTOR_H          "ls_Vector.h"
#define LS_VECTOR_C          "ls_Vector.cpp"

#endif

